﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using Infragistics.Documents.Excel;

namespace UltraGridChildBandExportToExcel
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGridExcelExporter1.ExportEnding += new Infragistics.Win.UltraWinGrid.ExcelExport.ExportEndingEventHandler(ultraGridExcelExporter1_ExportEnding);
            this.ultraGrid1.DataSource = GetData();
        }

        private void ultraGridExcelExporter1_ExportEnding(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.ExportEndingEventArgs e)
        {
            foreach (WorksheetRow worksheetRow in e.CurrentWorksheet.Rows)
            {
                worksheetRow.Hidden = false;
            }
        }

        private DataSet GetData(int rows = 7)
        {
            DataSet dataSet = new DataSet();

            DataTable tableOne = new DataTable("Table1");

            tableOne.Columns.Add("Boolean column", typeof(bool));
            tableOne.Columns.Add("Integer column", typeof(int));
            tableOne.Columns.Add("DateTime column", typeof(DateTime));
            tableOne.Columns.Add("String column", typeof(string));

            for (int i = 0; i < rows; i++)
            {
                DataRow row = tableOne.NewRow();
                row["Boolean column"] = i % 2 == 0 ? true : false;
                row["Integer column"] = i;
                row["String column"] = "text";
                row["DateTime column"] = DateTime.Today.AddDays(i);
                tableOne.Rows.Add(row);
            }

            DataTable tableTwo = new DataTable("Table2");

            tableTwo.Columns.Add("Boolean column", typeof(bool));
            tableTwo.Columns.Add("Integer column", typeof(int));
            tableTwo.Columns.Add("DateTime column", typeof(DateTime));
            tableTwo.Columns.Add("String column", typeof(string));

            for (int i = 0; i < rows; i++)
            {
                DataRow row = tableTwo.NewRow();
                row["Boolean column"] = i % 2 == 0 ? true : false;
                row["Integer column"] = i;
                row["String column"] = "text";
                row["DateTime column"] = DateTime.Today.AddDays(i);
                tableTwo.Rows.Add(row);
            }

            DataTable tableThree = new DataTable("Table3");

            tableThree.Columns.Add("Boolean column", typeof(bool));
            tableThree.Columns.Add("Integer column", typeof(int));
            tableThree.Columns.Add("DateTime column", typeof(DateTime));
            tableThree.Columns.Add("String column", typeof(string));

            for (int i = 0; i < rows; i++)
            {
                DataRow row = tableThree.NewRow();
                row["Boolean column"] = i % 2 == 0 ? true : false;
                row["Integer column"] = i;
                row["String column"] = "text";
                row["DateTime column"] = DateTime.Today.AddDays(i);
                tableThree.Rows.Add(row);
            }

            dataSet.Tables.Add(tableOne);
            dataSet.Tables.Add(tableTwo);
            dataSet.Tables.Add(tableThree);

            dataSet.Relations.Add(tableOne.Columns["Integer column"], tableTwo.Columns["Integer column"]);
            dataSet.Relations.Add(tableTwo.Columns["Integer column"], tableThree.Columns["Integer column"]);

            return dataSet;
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            var path = "c:\\exportedGrid.xlsx";
            this.ultraGridExcelExporter1.Export(this.ultraGrid1, path, Infragistics.Documents.Excel.WorkbookFormat.Excel2007);
            Process.Start(path);
        }
    }
}
